#!/usr/bin/env python
# Return the name of the applications currently registered

import atspi

def dump_node_content (node):
    for c in xrange(node.getChildCount()):
        inner_node = node.getChildAtIndex(c)
        if (inner_node.getName() != ""):
            print "\tNode name: " + inner_node.getName() + "::" + inner_node.getDescription ()
#            print "Node elements: %d" % inner_node.getChildCount()
        dump_node_content(inner_node)

if __name__ == "__main__":
    desk = atspi.registry.getDesktop(0)
    for i in xrange(desk.getChildCount()):
        app = desk.getChildAtIndex(i)
        print "Index: %d" % i
        print "Application name: %s" % app.getName()
        print "Application elements: %d" % app.getChildCount()
        dump_node_content (app)
        print
